;-----------------------------------------
; IC
;-----------------------------------------

	; clear SSPOV. On se moque des
	; overflow. tant pis si on a rat une
	; donne
	BCF SSPCON,SSPOV                      ; SSPCON.SSPOV = 0

	; On envoie un impulsion lumineuse
	; sur la led jeune
	banksel LED_J_CTR
	MOVLW PULSE
	MOVWF LED_J_CTR                       ; LED_J_CTR = PULSE

	; on teste si on est en train de
	; faire une ecriture
	; 1: lecture / 0: ecriture
	banksel SSPSTAT
	BTFSS SSPSTAT,READ_WRITE              ; if ( SSPSTAT.READ_WRITE == 1 ) {
	GOTO i2c_write

	;xxxxxxxxxxxxxxxxxxxxxxxxxx
	;
	;
	; c'est une lecture
	; Le master veut rcuprer la donne
	; qui correspond au pointeur courant
	;
	;
	;xxxxxxxxxxxxxxxxxxxxxxxxxx

	; maintain clock down
	banksel SSPCON
	BCF SSPCON,CKP                        ; SSPCON.CKP = 0

	; on va lire l'adresse envoye,
	; comme a on vide le buffer de
	; reception, et on evite l'overflow
	; c'est pas forcement utile, car il
	; est sens tre vide.
	banksel SSPBUF
	MOVFW SSPBUF                          ;    W = SSPBUF

	; positionne le bit IRP pour choisir
	; la bonne banque de donnes
	BCF STATUS,IRP                        ;    STATUS.IRP = 0

	; on s'assure que l'on ne depasse
	; pas l'adresse I2C_READ_MEMORY_STOP
	banksel I2C_ADDR
	MOVLW I2C_READ_MEMORY_STOP - I2C_READ_MEMORY_START
	SUBWF I2C_ADDR,W
	BTFSS STATUS,C                        ;    if ( I2C_ADDR > I2C_READ_MEMORY_STOP - I2C_READ_MEMORY_START ) {
	GOTO i2c_no_overflow

	MOVLW 0xFF                            ;        W = 0xff
	GOTO i2c_sendw                        ;        et hop, on saute vers l'ecriture i2c

i2c_no_overflow                          ;    }


	; on charge le pointeur sur l'adresse
	; dans le registre d'indirection
	banksel I2C_ADDR
	MOVFW I2C_ADDR
	ADDLW I2C_READ_MEMORY_START
	MOVWF FSR                             ;    FSR = I2C_ADDR

	; lit le resultat dans INDF et le
	; mets dans SSPBUF pour le fournir 
i2c_wcol_retry                           ;    loop {
	MOVFW INDF

i2c_sendw
	banksel SSPBUF
	MOVWF SSPBUF                          ;       SSPBUF = INDF (*I2C_ADDR)

	; Ce bit est postionn si l'ecriture
	; dans le buffer a choue car le SSP
	; est occup. Cela ne doit pas
	; arriver. Si c'est arriv, on clear
	; le bit et on rentante l'ecriture
	banksel SSPCON
	BTFSS SSPCON,WCOL                     ;       if ( SSPCON.WCOL == 1 ) {
	GOTO i2c_wcol_ok
	BCF SSPCON,WCOL                       ;          SSPCON.WCOL = 0
	GOTO i2c_wcol_retry                   ;       }
i2c_wcol_ok                              ;    }

	; incremente l'adresse pour le coup
	; suivant
	banksel I2C_ADDR
	INCF I2C_ADDR,F                       ;    I2C_ADDR++

	; release clock
	; le bug de l'i2c
	banksel SSPCON
	BSF SSPCON,CKP                        ; SSPCON.CKP = 1

	; on a fini
	GOTO i2c_end                          ; }

	;xxxxxxxxxxxxxxxxxxxxxxxxxx
	;
	;
	; C'est une ecriture
	; Le master envoi l'adresse qu'il
	; veut lire
	; 
	;
	;xxxxxxxxxxxxxxxxxxxxxxxxxx
i2c_write                                ; else {

	; on traite la lecture uniquement
	; si le buffer est plein
	banksel SSPSTAT
	BTFSS SSPSTAT,BF                      ;    if ( SSPSTAT.BF == 1 ) {
	GOTO i2c_end

	; que ce soit une donne ou une
	; adresse, je lis l'adresse demand
	; par le write l'i2c
	banksel SSPBUF
	MOVFW SSPBUF                          ;       W = SSPBUF

	; en mode ecriture, on a rien a faire
	; si on se fait reveiller apres
	; reception de l'adresse
	; 1: data / 0: adresse
	BTFSS SSPSTAT,DATA_ADDRESS            ;       if ( SSPSTAT.DATA_ADDRESS == 1 ) {
	GOTO i2c_end

	; on ajoute l'adresse demande par le
	; master  l'adresse de base. Elle
	; sert d'offset
	banksel I2C_ADDR
	MOVWF I2C_ADDR                        ;          I2C_ADDR = W
	                                      ;       }
	                                      ;    }
i2c_end                                  ; }
