;--------------------------------------------------------
;
; Cette portion de code allume les led par multiple de 
; ACTIONLED ms.
;
; Il prend en entre les compteurs LED_J_CTR et LED_R_CTR.
; Ces compteurs contiennent le nombre de multiple de
; ACTIONLED ms pendant lesquels la led reste allume.
;
;--------------------------------------------------------

	banksel LED_J_CTR ; LED_J_CTR est dans la mme banque que PORTB

;----------------------------------
; Est-ce l'heure de faire bip ?
;----------------------------------

	; On dcrmente le compteur, s'il na
	; pas atteint 0, on a fini le
	; traitement des leds.
	DECFSZ LED_DELAI,F                    ; LED_DELAI --
	GOTO irq_led_end                      ; if ( LED_DELAI == 0 ) {

	; On a fini de compter, on recharge
	; le compteur de ms
	MOVLW ACTIONLED
	MOVWF LED_DELAI                       ;    LED_DELAI = ACTIONLED


;----------------------------------
; update led 1 -> led jaune
;----------------------------------

	; on teste si le compteur de la led
	; est a 0. Pour cela, on fait un OU
	; avec un 0x00.
	CLRW
	IORWF LED_J_CTR,F
	BTFSS STATUS,Z                        ;    if ( LED_J_CTR == 0 ) {
	GOTO update_led_jaune_on

	; Si on arrive la, c'est que le
	; compteur est  zro, on teint
	; donc la led, et on a fini pour
	; celle l.
	BSF PORTB,LED_J                       ;       PORTB.LED_J = 1 (teint la led)
	GOTO update_led_rouge                 ;    }

	                                      ;    else {
update_led_jaune_on
	; Si on arrive la, il faut allumer
	; la led et dcrmenter le compteur
	; de cycles d'allumage.
	DECF LED_J_CTR,F                      ;       LED_J_CTR --
	BCF PORTB,LED_J                       ;       PORTB.LED_J = 0 (allume la led)
	                                      ;    }

;----------------------------------
; update led 2 -> led rouge
;----------------------------------

update_led_rouge
	; ici W doit valoir 0
	; car on ne l'a pas touch
	IORWF LED_R_CTR,F
	BTFSS STATUS,Z                        ;    if ( LED_R_CTR == 0 ) {
	GOTO update_led_rouge_on

	; Si on arrive la, c'est que le
	; compteur est a zro, on atteint donc
	; la led, et on a fini pour celle l.
	BSF PORTB,LED_R                       ;       PORTB.LED_R = 1 (teint la led)
	GOTO irq_led_end                      ;    }

	                                      ;    else {
update_led_rouge_on
	; Si on arrive la, il faut allumer
	; la led et dcrmenter le compteur
	; de cycles d'allumage
	DECF LED_R_CTR,F                      ;       LED_R_CTR --
	BCF PORTB,LED_R                       ;       PORTB.LED_R = 0 (allume la led)
	                                      ;    }

irq_led_end
	                                      ; }
